//----------------------------------------------------------------------------------------
//                                                               Schaff Trend Cycle EA.mq4 
//                                                                                  mladen 
//----------------------------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

//
//
//
//
//

extern int    MagicNumber         = 123456;
extern string _                   = "Shaff parameters";
extern int    SchaffPeriod        = 10;
extern int    FastMAPeriod        = 23;
extern int    SlowMAPeriod        = 50;
extern int    MainSignalTimeFrame = 30;
extern int    UseBar              = 1;
extern double ValueForBuy         = 15;
extern double ValueForSell        = 85;
extern string __                  = "Orders parameters";
extern double LotSize             = 0.1;
extern int    StopLossPips        = 0;
extern int    TakeProfitPips      = 15;
extern string ___                 = "Broker parameters";
extern bool   EcnBroker           = false;
extern bool   NoHedge             = false;

//----------------------------------------------------------------------------------------
//       
//----------------------------------------------------------------------------------------
//
//
//
//
//

int init()   { return(0); }
int deinit() { return(0); }

//
//
//
//
//

#define _mainTrendUp    1
#define _mainTrendDown -1

int start()
{
   int    majorTrend = iCustom(NULL,MainSignalTimeFrame,"stc for EA",SchaffPeriod,FastMAPeriod,SlowMAPeriod,1,UseBar);   
   double minorValue = iCustom(NULL,0                  ,"stc for EA",SchaffPeriod,FastMAPeriod,SlowMAPeriod,0,UseBar);

   //
   //
   //
   //
   //
   
      if (majorTrend == _mainTrendUp)   closeOrders(OP_SELL);
      if (majorTrend == _mainTrendDown) closeOrders(OP_BUY);
      
      //
      //
      //
      //
      //

         int  openedBuys, openedSells; 
              countOpenedOrders(openedBuys,openedSells);
               
              bool openBuy  = (majorTrend == _mainTrendUp   && minorValue<ValueForBuy  && openedBuys  == 0);
              bool openSell = (majorTrend == _mainTrendDown && minorValue>ValueForSell && openedSells == 0);
    
         if (NoHedge && openedSells>0) openBuy  = false;
         if (NoHedge && openedBuys >0) openSell = false;

      //
      //
      //
      //
      //
         
         int    retries,ticket;      
         double takeProfit = TakeProfitPips*Point;
         double stopLoss   = StopLossPips*Point;
            if (Digits==3 || Digits==5) 
            {
               takeProfit *= 10;
               stopLoss   *= 10;
            }

            //
            //
            //
            //
            //
         
            if (openBuy)
            {
               
               retries=  0;
               ticket = -1;
               while(ticket == -1 && retries < 3)
               {
                  RefreshRates();
                  double bsl = 0; if (stopLoss  !=0) bsl=Bid-stopLoss;
                  double btp = 0; if (takeProfit!=0) btp=Ask+takeProfit;
                  
                  if (!EcnBroker)
                        ticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,0,bsl,btp,"",MagicNumber,0,CLR_NONE);
                  else 
                     {
                        ticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,0,0,0,"",MagicNumber,0,CLR_NONE);
                        if (ticket>=0)
                           OrderModify(ticket,OrderOpenPrice(),bsl,btp,0,CLR_NONE);
                     }                        
                  if (ticket!=-1) break; retries++;
               }   
               return(0);
            }               

            //
            //
            //
            //
            //
               
            if (openSell)
            {
               retries=  0;
               ticket = -1;
               while(ticket == -1 && retries < 3)
               {
                  RefreshRates();
                  double ssl = 0; if (stopLoss  !=0) ssl=Ask+stopLoss;
                  double stp = 0; if (takeProfit!=0) stp=Bid-takeProfit;
                  if (!EcnBroker)
                        ticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,0,ssl,stp,"",MagicNumber,0,CLR_NONE);
                  else
                     {
                        ticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,0,0,0,"",MagicNumber,0,CLR_NONE);
                        if (ticket>=0)
                           OrderModify(ticket,OrderOpenPrice(),ssl,stp,0,CLR_NONE);
                     }                        
                     if(ticket!=-1) break; retries++;
               }
               return(0);
            }      
   
   //
   //
   //
   //
   //
                     
   return(0);
}

//----------------------------------------------------------------------------------------
//       
//----------------------------------------------------------------------------------------
//
//
//
//
//

void countOpenedOrders(int& openedBuys,int& openedSells)
{
   openedBuys   = 0;
   openedSells  = 0;
       
   //
   //
   //
   //
   //
       
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderSymbol() != Symbol()) continue;
      if(OrderMagicNumber() != MagicNumber) continue;
                  
         if(OrderType() == OP_BUY)  openedBuys++;
         if(OrderType() == OP_SELL) openedSells++;
   }      
   return;
}

//----------------------------------------------------------------------------------------
//       
//----------------------------------------------------------------------------------------
//
//
//
//
//

void closeOrders(int orderType)
{
   for(int i=OrdersTotal()-1; i>=0; i--) 
   {
      if(OrderSelect(i,SELECT_BY_POS, MODE_TRADES)==false) break;            
      if(OrderMagicNumber() != MagicNumber)            continue;
      if(OrderType()        != orderType)              continue;
      if(OrderSymbol()      != Symbol())               continue;

      //
      //
      //
      //
      //
      
      RefreshRates(); 
      switch(orderType)
      {
         case OP_BUY  :  OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE); break;
         case OP_SELL :  OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE); break;
      }
   }
}

